#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <stdio.h>
#include <stdlib.h>
#include <ggi/types.h>
#include <ggi/ggi.h>
#ifdef __cplusplus
}
#endif



static int
not_here(s)
char *s;
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

static double
constant(name, arg)
char *name;
int arg;
{
    errno = 0;
    switch (*name) {
    case 'A':
	if (strEQ(name, "ATTR_BGCOLOR"))
#ifdef ATTR_BGCOLOR
	    return ATTR_BGCOLOR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTR_BLINK"))
#ifdef ATTR_BLINK
	    return ATTR_BLINK;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTR_BOLD"))
#ifdef ATTR_BOLD
	    return ATTR_BOLD;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTR_BRIGHT"))
#ifdef ATTR_BRIGHT
	    return ATTR_BRIGHT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTR_FGCOLOR"))
#ifdef ATTR_FGCOLOR
	    return ATTR_FGCOLOR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTR_FONT"))
#ifdef ATTR_FONT
	    return ATTR_FONT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTR_HALF"))
#ifdef ATTR_HALF
	    return ATTR_HALF;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTR_INTENSITY"))
#ifdef ATTR_INTENSITY
	    return ATTR_INTENSITY;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTR_ITALIC"))
#ifdef ATTR_ITALIC
	    return ATTR_ITALIC;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTR_NORMAL"))
#ifdef ATTR_NORMAL
	    return ATTR_NORMAL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTR_REVERSE"))
#ifdef ATTR_REVERSE
	    return ATTR_REVERSE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTR_UNDERLINE"))
#ifdef ATTR_UNDERLINE
	    return ATTR_UNDERLINE;
#else
	    goto not_there;
#endif
	break;
    case 'B':
	break;
    case 'C':
	break;
    case 'D':
	break;
    case 'E':
	break;
    case 'F':
	break;
    case 'G':
	if (strEQ(name, "GGI_BM_SUB_ALPHA"))
#ifdef GGI_BM_SUB_ALPHA
	    return GGI_BM_SUB_ALPHA;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_BGCOL"))
#ifdef GGI_BM_SUB_BGCOL
	    return GGI_BM_SUB_BGCOL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_BLINK"))
#ifdef GGI_BM_SUB_BLINK
	    return GGI_BM_SUB_BLINK;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_BLUE"))
#ifdef GGI_BM_SUB_BLUE
	    return GGI_BM_SUB_BLUE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_BOLD"))
#ifdef GGI_BM_SUB_BOLD
	    return GGI_BM_SUB_BOLD;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_CLUT"))
#ifdef GGI_BM_SUB_CLUT
	    return GGI_BM_SUB_CLUT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_CYAN"))
#ifdef GGI_BM_SUB_CYAN
	    return GGI_BM_SUB_CYAN;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_FGCOL"))
#ifdef GGI_BM_SUB_FGCOL
	    return GGI_BM_SUB_FGCOL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_FONTSEL"))
#ifdef GGI_BM_SUB_FONTSEL
	    return GGI_BM_SUB_FONTSEL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_GREEN"))
#ifdef GGI_BM_SUB_GREEN
	    return GGI_BM_SUB_GREEN;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_INTENSITY"))
#ifdef GGI_BM_SUB_INTENSITY
	    return GGI_BM_SUB_INTENSITY;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_ITALIC"))
#ifdef GGI_BM_SUB_ITALIC
	    return GGI_BM_SUB_ITALIC;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_K"))
#ifdef GGI_BM_SUB_K
	    return GGI_BM_SUB_K;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_MAGENTA"))
#ifdef GGI_BM_SUB_MAGENTA
	    return GGI_BM_SUB_MAGENTA;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_MODESEL"))
#ifdef GGI_BM_SUB_MODESEL
	    return GGI_BM_SUB_MODESEL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_PALSEL"))
#ifdef GGI_BM_SUB_PALSEL
	    return GGI_BM_SUB_PALSEL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_RED"))
#ifdef GGI_BM_SUB_RED
	    return GGI_BM_SUB_RED;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_TEXNUM"))
#ifdef GGI_BM_SUB_TEXNUM
	    return GGI_BM_SUB_TEXNUM;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_U"))
#ifdef GGI_BM_SUB_U
	    return GGI_BM_SUB_U;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_UNDERLINE"))
#ifdef GGI_BM_SUB_UNDERLINE
	    return GGI_BM_SUB_UNDERLINE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_V"))
#ifdef GGI_BM_SUB_V
	    return GGI_BM_SUB_V;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_WINDOWID"))
#ifdef GGI_BM_SUB_WINDOWID
	    return GGI_BM_SUB_WINDOWID;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_WRITEPROT"))
#ifdef GGI_BM_SUB_WRITEPROT
	    return GGI_BM_SUB_WRITEPROT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_Y"))
#ifdef GGI_BM_SUB_Y
	    return GGI_BM_SUB_Y;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_YELLOW"))
#ifdef GGI_BM_SUB_YELLOW
	    return GGI_BM_SUB_YELLOW;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_SUB_ZBUFFER"))
#ifdef GGI_BM_SUB_ZBUFFER
	    return GGI_BM_SUB_ZBUFFER;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_TYPE_ATTRIB"))
#ifdef GGI_BM_TYPE_ATTRIB
	    return GGI_BM_TYPE_ATTRIB;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_TYPE_COLOR"))
#ifdef GGI_BM_TYPE_COLOR
	    return GGI_BM_TYPE_COLOR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_TYPE_LOGIC"))
#ifdef GGI_BM_TYPE_LOGIC
	    return GGI_BM_TYPE_LOGIC;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_BM_TYPE_NONE"))
#ifdef GGI_BM_TYPE_NONE
	    return GGI_BM_TYPE_NONE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_COLOR_PRECISION"))
#ifdef GGI_COLOR_PRECISION
	    return GGI_COLOR_PRECISION;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_PALETTE_DONTCARE"))
#ifdef GGI_PALETTE_DONTCARE
	    return GGI_PALETTE_DONTCARE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_PF_EXTENDED"))
#ifdef GGI_PF_EXTENDED
	    return GGI_PF_EXTENDED;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_PF_HAM"))
#ifdef GGI_PF_HAM
	    return GGI_PF_HAM;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_PF_HIGHBIT_RIGHT"))
#ifdef GGI_PF_HIGHBIT_RIGHT
	    return GGI_PF_HIGHBIT_RIGHT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "GGI_PF_REVERSE_ENDIAN"))
#ifdef GGI_PF_REVERSE_ENDIAN
	    return GGI_PF_REVERSE_ENDIAN;
#else
	    goto not_there;
#endif
	break;
    case 'H':
	break;
    case 'I':
	break;
    case 'J':
	break;
    case 'K':
	break;
    case 'L':
	break;
    case 'M':
	break;
    case 'N':
	break;
    case 'O':
	break;
    case 'P':
	break;
    case 'Q':
	break;
    case 'R':
	break;
    case 'S':
	break;
    case 'T':
	break;
    case 'U':
	break;
    case 'V':
	break;
    case 'W':
	break;
    case 'X':
	break;
    case 'Y':
	break;
    case 'Z':
	break;
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}



MODULE = GGI::Pixel		PACKAGE = GGI::Pixel		


double
constant(name,arg)
	char *		name
	int		arg

void *
ggi_malloc_pixels(vis, npix)
	ggi_visual_t	vis
	size_t		npix
	CODE:
	RETVAL = malloc(npix * ((ggiGetPixelFormat(vis)->size+7)/8));
	OUTPUT:
	RETVAL

void
ggi_free_pixels(buff)
	void *	buff
	CODE:
	free(buff);

void *
ggi_realloc_pixels(vis, buff, npixnew, npixold)
	ggi_visual_t	vis
	void *		buff
	size_t		npixnew
	size_t		npixold
	CODE:
	RETVAL = realloc(buff, npixnew * ((ggiGetPixelFormat(vis)->size+7)/8));
	if (RETVAL == NULL) {
		npixnew = npixold;
		RETVAL = buff;
	}
	OUTPUT:
	RETVAL
	npixnew

int
ggi_get_pixel_size(vis)
	ggi_visual_t	vis
	CODE:
	RETVAL = ((ggiGetPixelFormat(vis)->size+7)/8);
	OUTPUT:
	RETVAL

const ggi_pixelformat *
ggiGetPixelFormat(vis)
	ggi_visual_t	vis

ggi_pixel
ggiMapColor(vis, col)
	ggi_visual_t	vis
	ggi_color *	col

int
ggiUnmapPixel(vis, pixel, col)
	ggi_visual_t	vis
	ggi_pixel	pixel
	ggi_color *	col

int
ggiPackColors(vis, buf, cols, len)
	ggi_visual_t	vis
	void *	buf
	ggi_color *	cols
	int	len

int
ggiUnpackPixels(vis, buf, cols, len)
	ggi_visual_t	vis
	void *	buf
	ggi_color *	cols
	int	len

