#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ggi/ggi.h"
#ifdef __cplusplus
}
#endif


MODULE = GGI::Mode		PACKAGE = GGI::Mode		


sint16
GGI_AUTO()
	CODE:
	RETVAL = GGI_AUTO;
	OUTPUT:
	RETVAL

ggi_mode *
ggi_mode_malloc()
	CODE:
	RETVAL = malloc(sizeof(ggi_mode));
	OUTPUT:
	RETVAL

void
ggi_mode_free(obj)
	ggi_mode *obj;
	CODE:
	free(obj);

sint32
ggi_mode_get_member_frames(obj) 
	ggi_mode *obj
	CODE:
	RETVAL = obj->frames;
	OUTPUT:
	RETVAL

sint32
ggi_mode_set_member_frames(obj, val) 
	ggi_mode *obj
	sint32 val
	CODE:
	obj->frames = val;
	RETVAL = obj->frames;
	OUTPUT:
	RETVAL

ggi_coord *
ggi_mode_get_member_visible(obj) 
	ggi_mode *obj
	CODE:
	RETVAL = &(obj->visible);
	OUTPUT:
	RETVAL

ggi_coord *
ggi_mode_get_member_virt(obj) 
	ggi_mode *obj
	CODE:
	RETVAL = &(obj->virt);
	OUTPUT:
	RETVAL

ggi_coord *
ggi_mode_get_member_dpp(obj) 
	ggi_mode *obj
	CODE:
	RETVAL = &(obj->dpp);
	OUTPUT:
	RETVAL

ggi_coord *
ggi_mode_get_member_size(obj) 
	ggi_mode *obj
	CODE:
	RETVAL = &(obj->size);
	OUTPUT:
	RETVAL

ggi_graphtype *
ggi_mode_get_member_graphtype(obj) 
	ggi_mode *obj
	CODE:
	RETVAL = &(obj->graphtype);
	OUTPUT:
	RETVAL

int
ggiSPrintMode(s, m)
        char *  s
        ggi_mode *      m

int
ggiParseMode(s, m)
        const char *    s
        ggi_mode *      m
